#pragma once
#include "vector_inl.h"

class Viewer {
public:
	Viewer();
	~Viewer();

	Vector3d lowerLimit;
	Vector3d upperLimit;

	void Strafe(double impulse);
	void Accelerate(double distance);
	void Turn(double angle) ;
	void Tilt(double angle) ;
	void TiltTo(double angle) ;
	void SetPosition(const Vector3d & newPostion);
	void LookAt(const Vector3d & newPostion) { forward = newPostion; };
	void SetLimits(Vector3d upper, Vector3d lower);
	void Update(const double & ms);
	void Update(const double & ms, double height);

	bool IsNotActive();
	bool IsActive();

	const Vector3d & GetPosition();
	const Vector3d & GetForward();
	const double & GetVelocity();
	const double & GetAcceleration();

	Vector3d Up();
	double Tilt() const;
	Vector3d LookAt();
	Vector3d Direction();
	Vector3d Position();
	void SetHeight(double newHeight);
	void ChangeHeightBy(double newHeight);
	void RotateYby(const double& angle);
	void RotateYto(const double& angle);
	void PitchBy(const double& angle);

private:
	double tiltAngle;
	Vector3d up;
	Vector3d forward;
	Vector3d position;
	double height;

	void ClampToLimits();
	double acceleration;
	double velocity;
	double maxVelocity;
	double strafeMaxVelocity;
	double strafeVelocity;
	double strafeAcceleration;
	double angularAcceleration;
	double angularVelocity;
	double maxAngularVelocity;
	double angularTiltVelocity;
};
