// after mediator/builder pattern
#pragma once
#include <string>
#include <Map>
#include "Mesh.h"
#include "ObjFileReader.h"

using namespace std;
using namespace MeshTools;

class MeshDataLoader {
private:
  static Mesh* mesh;
  static Face* face;
  static vector<string> currentGroups;
  static int currentFace;

public:
  MeshDataLoader();
  ~MeshDataLoader();

  static void Load(const string filename, Mesh &mesh);

  static std::map<FunctionIDs, PtrToFunVecStr> AvailableFunctions();

  static void AddVertex(const vector<string>& vertex);
  static void AddNormal(const vector<string>& normal);
  static void AddTexture(const vector<string>& texture);
  
  static void AddVertexIndices(const vector<string>& vertexIndicesAll);
  static void AddNormalIndices(const vector<string>& normalIndices);
  static void AddTextureIndices(const vector<string>& textureIndices);
  
  static void AddFaceV(const vector<string>& indices);
  static void AddFaceVT(const vector<string>& indices);
  static void AddFaceVN(const vector<string>& indices);
  static void AddFaceVTN(const vector<string>& indices);
  static void AddMaterial(const vector<string>& material);

  static void SetGroups(const vector<string>& groupNames);
  static void SetMaterial(const vector<string>& material);
};
