#include "vector_inl.h"

struct orientation {
	orientation() : matrix()
	{ 
		matrix[0] = 1; matrix[5] = 1; matrix[10] = 1; matrix[15] = 1;
	};

	float matrix[16];

	void PitchBy(int iDegrees);
	void YawBy(int iDegrees);
};


void orientation::PitchBy(int iDegrees){
// rotate about local X
  float fRadians = iDegrees * 3.141592653589793 / 180 ;

  Vector3d LocalX, LocalY, LocalZ;
  LocalX.x = matrix[0];
  LocalX.y = ( cos(fRadians) * matrix[1]) + (sin(fRadians) * matrix[2]);
  LocalX.z = (-sin(fRadians) * matrix[1]) + (cos(fRadians) * matrix[2]);

  LocalY.x =  matrix[4];
  LocalY.y = ( cos(fRadians) * matrix[5]) + (sin(fRadians) * matrix[6]);
  LocalY.z = (-sin(fRadians) * matrix[5]) + (cos(fRadians) * matrix[6]);

  LocalZ.x =  matrix[8];
  LocalZ.y = ( cos(fRadians) * matrix[9]) + (sin(fRadians) * matrix[10]);
  LocalZ.z = (-sin(fRadians) * matrix[9]) + (cos(fRadians) * matrix[10]);

  LocalX = Normalize(LocalX);
  LocalY = Normalize(LocalY);
  LocalZ = Normalize(LocalZ);

  //matrix[0] = LocalX.x ;
  matrix[1] = LocalX.y ;
  matrix[2] = LocalX.z ;
  //matrix[4] = LocalY.x ;
  matrix[5] = LocalY.y ;
  matrix[6] = LocalY.z ;
  //matrix[8] = LocalZ.x ;
  matrix[9] = LocalZ.y ;
  matrix[10] = LocalZ.z ;
};

void orientation::YawBy(int iDegrees){
// rotate about local Y
  float fRadians = iDegrees * 3.141592653589793 / 180 ;
  Vector3d LocalX, LocalY, LocalZ;
  LocalX.x = (cos(fRadians) * matrix[0]) + (-sin(fRadians) * matrix[2]);
  LocalX.y = matrix[1];
  LocalX.z = (sin(fRadians) * matrix[0]) + ( cos(fRadians) * matrix[2]);

  LocalY.x = (cos(fRadians) * matrix[4]) + (-sin(fRadians) * matrix[6]);
  LocalY.y = matrix[5];
  LocalY.z = (sin(fRadians) * matrix[4]) + ( cos(fRadians) * matrix[6]);

  LocalZ.x = (cos(fRadians) * matrix[8]) + (-sin(fRadians) * matrix[10]);
  LocalZ.y = matrix[9];
  LocalZ.z = (sin(fRadians) * matrix[8]) + ( cos(fRadians) * matrix[10]);

  matrix[0] = LocalX.x ;
  //matrix[1] = LocalX.y ;
  matrix[2] = LocalX.z ;
  matrix[4] = LocalY.x ;
  //matrix[5] = LocalY.y ;
  matrix[6] = LocalY.z ;
  matrix[8] = LocalZ.x ;
  //matrix[9] = LocalZ.y ;
  matrix[10] = LocalZ.z ;
};
